/*
 * @Author: Kane
 * @Date: 2023-05-15 14:59:26
 * @LastEditors: Kane
 * @FilePath: /desktop_archievement_backend/src/test/java/com/cpic/xim/DesktopArchievement/test/DesktopArchievementTest.java
 * @Description: 
 * 
 * Copyright (c) ${2022} by Kane, All Rights Reserved. 
 */
package com.cpic.xim.DesktopArchievement.test;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;
import java.io.IOException;
import java.io.InputStream;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Test;
import com.cpic.xim.mybatis.mapper.ArchievementMapper;
import com.cpic.xim.mybatis.pojo.MensualArchievementItem;
import com.cpic.xim.utils.ranking.CallerRankingList;



@SuppressWarnings( "all" )
public class DesktopArchievementTest
{
    private static String configFilePath = "mybatis/mybatis-config.xml";

    @Test
    public void testCallerRankingList()
    {
        CallerRankingList rankingList = null;

        try
        {
            rankingList = CallerRankingList.getCallerRankingList( "QDI", "2023", "06" );
        }
        catch ( SQLException error )
        {
            error.printStackTrace();
        }
        catch ( ClassNotFoundException error )
        {
            error.printStackTrace();
        }

        assertNotNull( rankingList );
    }

    @Test
    public void testDepartmentArchievement()
    {
        try
        {
            InputStream configFile = Resources.getResourceAsStream( configFilePath );
            SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
            SqlSessionFactory factory = builder.build( configFile );
            SqlSession session = factory.openSession();

            ArchievementMapper mapper = session.getMapper( ArchievementMapper.class );
            ArrayList<MensualArchievementItem> mensual = null;
            HashMap<String, Object> params = new HashMap<>();

            params.put( "a_department_code", "QDI" );

            mapper.getDepartmentArchievement( params );

            mensual = (List<MensualArchievementItem>)params.get("a_mensual_cur");

            System.out.println( params.toString() );
            System.out.println( mensual.toString() );

            assertTrue( params.size() > 1 );
        }
        catch ( IOException error )
        {
            assert (false);
        }
    }
}
